"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.binarySearch = void 0;
const operators_1 = require("rxjs/operators");
const binary_search_1 = require("../utils/binary-search");
function binarySearch(searchValue, sort, property) {
    const sortFn = sort ? sort : binary_search_1.defaultSearch;
    return (source) => source.pipe(operators_1.reduce((acc, val) => (Array.isArray(val) ? (property && typeof property === 'number' ? [...acc, val] : [...acc, ...val]) : [...acc, val]), []), operators_1.map((accArray) => accArray.sort(sortFn)), operators_1.map((sortedArray) => ({
        searchValue: searchValue,
        searchArray: sortedArray,
        index: binary_search_1.binarySearcher(searchValue, sortedArray, property),
    })));
}
exports.binarySearch = binarySearch;
//# sourceMappingURL=binary-search.js.map